<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\Sport;
use Exception;
use Illuminate\Database\Eloquent\ModelNotFoundException;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;
use Illuminate\Http\JsonResponse;
use Yajra\DataTables\Facades\DataTables;

class SportController extends Controller
{
    public function index()
    {
        $sports = Sport::orderBy('created_at', 'desc')->get();

        return view('admin.sports.index', compact('sports'));
    }

    public function getSportList(Request $request)
    {
        $sqlBuilder = Sport::select([
            'sports.id',
            'sports.name',
            'sports.name_ar',
            'sports.status',
            'sports.image',
        ]);

        return DataTables::of($sqlBuilder)
            ->filter(function ($query) use ($request) {
                if ($request->has('search') && !empty($request->search['value'])) {
                    $query->where('sports.name', 'ilike', "%" . $request->search['value'] . "%")
                    ->orWhere('sports.name_ar', 'ilike', "%" . $request->search['value'] . "%");
                }
            })
            ->editColumn('image', function ($data) {
                $icon = !empty($data->image) ? $data->image : asset('assets/images/camera_placeholder.png');
                return '<div style="text-align:center;"><img src="' . $icon . '" class="rounded-circle avatar-xs" alt="icon"></div>';
                
            })
            ->editColumn('status', function ($data) {
                return '<div class="status">
                <div class="form-check form-switch ">
                    <input class="form-check-input status-checkbox" type="checkbox" role="switch" id="SwitchCheck4" data-url="' . route('admin.sports.status', ['id' => $data->id]) . '" data-id="' . $data->id . '" ' . (!empty($data->status) && $data->status == 1 ? 'checked' : '') . ' />
                </div>
            </div>';
            })
            ->addColumn('action', function ($data) {
                $html = '<div class="dropdown">
                                        <a href="#" class="btn btn-soft-secondary btn-sm" role="button" id="dropdownMenuLink5" data-bs-toggle="dropdown" aria-expanded="false">
                                            <i class="ri-more-2-fill"></i>
                                        </a>
                                        <ul class="dropdown-menu" aria-labelledby="dropdownMenuLink5">
                                            <li><a class="dropdown-item" href="' . route('admin.sports.edit', ['id' => $data->id]) . '">Edit</a></li>
                                            <li><a class="dropdown-item delete-btn" data-url="' . route('admin.sports.destroy', ['id' => $data->id]) . '">Delete</a></li>
                                        </ul>
                                    </div>';
                return $html;
            })
            ->rawColumns(['image', 'status', 'action'])
            ->make(true);
    }

    public function create()
    {
        $sport = "";

        return view('admin.sports.create', compact('sport'));
    }

    public function store(Request $request)
    {
        $rules = [
            'name' => 'required|string|max:255',
            'name_ar' => 'required|string|max:255',
            'status' => 'required|in:0,1',
            'image' => 'nullable|image|mimes:jpeg,png,jpg,gif|max:2048',
        ];

        $validator = Validator::make($request->all(), $rules);

        if ($validator->fails()) {
            return response()->json([
                'status' => 'error',
                'errors' => $validator->errors(),
            ], 422);
        }

        if ($request->id) {
            $sport = Sport::find($request->id);

            if (!$sport) {
                return response()->json(['status' => 'error', 'message' => 'Sport not found'], 404);
            }

            $sport->name = $request->name;
            $sport->name_ar = $request->name_ar;
            $sport->status = $request->status;
            $sport->save();

            if($request->file("image")){
                $response = image_upload($request,config('global.sport_image_upload_dir'),'image');
                if($response['status']){
                    $sport->image = $response['link'];
                    $sport->save();
                }
            }

            return response()->json(['status' => 'success', 'message' => 'Sport updated successfully']);
        } else {
            $alreadyExists = Sport::where('name', $request->name)->orWhere('name_ar', $request->name_ar)->first();
            if ($alreadyExists) {
                return response()->json(['status' => 'error', 'message' => 'Sport already exists'], 422);
            }
            $sport = Sport::create([
                'name' => $request->name,
                'name_ar' => $request->name_ar,
                'status' => $request->status,
            ]);

            if($request->file("image")){
                $response = image_upload($request,config('global.sport_image_upload_dir'),'image');
                if($response['status']){
                    $sport->image = $response['link'];
                    $sport->save();
                }
            }

            return response()->json(['status' => 'success', 'message' => 'Sport added successfully', 'sport' => $sport]);
        }
    }

    public function edit($id)
    {
        $sport = Sport::findOrFail($id);

        return view('admin.sports.create', compact('sport'));
    }

    public function destroy($id): JsonResponse
    {
        try {
            $sport = Sport::findOrFail($id);
            $sport->delete();
            return response()->json([
                'status' => 'success',
                'message' => 'Sport deleted successfully.'
            ], 200);
        } catch (ModelNotFoundException $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'Sport not found.'
            ], 404);
        } catch (Exception $e) {
            return response()->json([
                'status' => 'error',
                'message' => 'An error occurred while deleting the sport.'
            ], 500);
        }
    }

    public function statusChange(Request $request, $id)
    {
        $sport = Sport::find($id);

        if (!$sport) {
            return response()->json([
                'status' => 'error',
                'message' => 'Sport not found.'
            ], 404);
        }

        $sport->status = $request->status;
        $sport->save();

        return response()->json([
            'status' => 'success',
            'message' => 'Sport status updated successfully.'
        ]);
    }
}
